> For the complete documentation index, see [llms.txt](https://docs.orbs.network/v3/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.orbs.network/v3/orbs-vm/step-by-step-overview.md).

# Step by Step Overview

The development process of a new Orbs VM service includes the following steps:<br>

1. **Select a unique ID** for your service (alpha-numeric characters and dashes).<br>
2. **Create a local git repository** conforming to the appropriate project structure.<br>
3. **Implement the logic** of your service in any language and wrap it as a single docker image.<br>
4. **Write a simple test suite** to verify your service logic locally.<br>
5. **Push your docker image** to a public docker registry such as [DockerHub](https://hub.docker.com/).<br>
6. **Deploy your service** by creating a PR (git pull request) to the official Orbs repo on GitHub.<br>
7. **Wait until service is deployed** by the system, errors and feedback will appear on the PR.<br>
8. **Analyze execution** of your service in production by examining the network [status page](https://status.orbs.network).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.orbs.network/v3/orbs-vm/step-by-step-overview.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
